Bug 820659 - Review Request: python-ufc - Unified Form-assembly Code
Review Request: python-ufc - Unified Form-assembly Code
Status: CLOSED NEXTRELEASE
Product: Fedora
Classification: Fedora
Component: Package Review (Show other bugs)
rawhide
All Linux
medium Severity medium
: ---
: ---
Assigned To: José Matos
Fedora Extras Quality Assurance
:
Depends On:
Blocks: FEniCS dolfin
  Show dependency treegraph
 
Reported: 2012-05-10 11:28 EDT by Jonathan Underwood
Modified: 2016-08-14 12:23 EDT (History)
4 users (show)

See Also:
Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2013-01-24 10:18:24 EST
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---
jamatos: fedora‑review+
limburgher: fedora‑cvs+


Attachments (Terms of Use)
Patch to spec file with changes to comply with guidelines (1.65 KB, patch)
2012-10-01 10:37 EDT, José Matos
no flags Details | Diff
Patch cmake file to install the pkg-config file in %{_libdir} (501 bytes, patch)
2012-10-01 10:39 EDT, José Matos
no flags Details | Diff

  None (edit)
Description Jonathan Underwood 2012-05-10 11:28:18 EDT
Spec URL: http://jgu.fedorapeople.org/python-ufc.spec
SRPM URL: http://jgu.fedorapeople.org/python-ufc-2.0.5-0.1.el6.src.rpm
Description: 
UFC (Unified Form-assembly Code) is a unified framework for finite element assembly. More precisely, it defines a fixed interface for communicating low level routines (functions) for evaluating and assembling finite element variational forms. The UFC interface consists of a single header file ufc.h that specifies a C++ interface that must be implemented by code that complies with the UFC specification.
Comment 1 José Matos 2012-10-01 06:47:25 EDT
Hi Jonathan,
  I will review this package but meanwhile there a showstopper. :-)

Such as it the package does not compile in Fedora because of the conditional on cmake:

%if (0%{?rhel} <= 6)
BuildRequires:  cmake28
%else
BuildRequires:  cmake
%endif

On Fedora this ends requiring cmake28 because rpm evaluates (0 <= 6) -> (true).

For the moment this is all, I will review this package later today fixing this issue.
Comment 2 José Matos 2012-10-01 10:37:12 EDT
Created attachment 619821 [details]
Patch to spec file with changes to comply with guidelines

Proposed changes to the spec file.
Comment 3 José Matos 2012-10-01 10:39:06 EDT
Created attachment 619823 [details]
Patch cmake file to install the pkg-config file in %{_libdir}

With this patch the pkg-config file is installed in %{_libdir}
Comment 4 José Matos 2012-10-01 11:07:38 EDT
Package Review
==============

Key:
[x] = Pass
[!] = Fail
[-] = Not applicable


Issues:
=======
[!]: Header files in -devel subpackage, if present.
     Note: python-ufc-2.0.5-0.2.fc17.x86_64.rpm : /usr/include/ufc.h
See: http://fedoraproject.org/wiki/Packaging/Guidelines#DevelPackages

Not a problem clearly this is a development package, so it is safe to
ignore the requirement.

[!]: Package contains BR: python2-devel or python3-devel
See: http://fedoraproject.org/wiki/Packaging:Python#BuildRequires


===== MUST items =====

C/C++:
[!]: Header files in -devel subpackage, if present.
     Note: python-ufc-2.0.5-0.2.fc17.x86_64.rpm : /usr/include/ufc.h
[x]: Package does not contain any libtool archives (.la)
[x]: Package does not contain kernel modules.
[x]: Package contains no static executables.
[x]: Rpath absent or only used for internal libs.
[-]: Development (unversioned) .so files in -devel subpackage, if present.
     Note: Unversioned so-files in private %_libdir subdirectory (see
     attachment). Verify they are not in ld path.

Generic:
[x]: Package is licensed with an open-source compatible license and meets
     other legal requirements as defined in the legal section of Packaging
     Guidelines.
[x]: Package successfully compiles and builds into binary rpms on at least one
     supported primary architecture.
[x]: %build honors applicable compiler flags or justifies otherwise.
[x]: All build dependencies are listed in BuildRequires, except for any that
     are listed in the exceptions section of Packaging Guidelines.
[x]: Package contains no bundled libraries.
[x]: Changelog in prescribed format.
[-]: Package does not run rm -rf %{buildroot} (or $RPM_BUILD_ROOT) at the
     beginning of %install.
     Note: rm -rf %{buildroot} present but not required
[x]: Sources contain only permissible code or content.
[x]: Each %files section contains %defattr if rpm < 4.4
     Note: %defattr present but not needed
[x]: Macros in Summary, %description expandable at SRPM build time.
[-]: Package contains desktop file if it is a GUI application.
[-]: Development files must be in a -devel package
[x]: Package requires other packages for directories it uses.
[x]: Package uses nothing in %doc for runtime.
[x]: Package is not known to require ExcludeArch.
[x]: Package does not contain duplicates in %files.
[x]: Permissions on files are set properly.
[x]: Package complies to the Packaging Guidelines
[x]: Spec file lacks Packager, Vendor, PreReq tags.
[x]: Large documentation files are in a -doc subpackage, if required.
[x]: If (and only if) the source package includes the text of the license(s)
     in its own file, then that file, containing the text of the license(s)
     for the package is included in %doc.
[x]: License field in the package spec file matches the actual license.
     Note: Checking patched sources after %prep for licenses. Licenses found:
     "Unknown or generated". 1 files have unknown license. Detailed output of
     licensecheck in /home/jamatos/tmp/fedora/review-python-
     ufc/licensecheck.txt
[x]: Package consistently uses macro is (instead of hard-coded directory
     names).
[x]: If the package is under multiple licenses, the licensing breakdown must
     be documented in the spec.
[x]: Package is named using only allowed ASCII characters.
[x]: Package is named according to the Package Naming Guidelines.
[x]: Package does not generate any conflict.
     Note: Package contains no Conflicts: tag(s)
[x]: Package do not use a name that already exist
[x]: Package obeys FHS, except libexecdir and /usr/target.
[-]: If the package is a rename of another package, proper Obsoletes and
     Provides are present.
[x]: Package must own all directories that it creates.
[x]: Package does not own files or directories owned by other packages.
[x]: Package installs properly.
[x]: Package is not relocatable.
[x]: Requires correct, justified where necessary.
[x]: CheckResultdir
[x]: Rpmlint is run on all rpms the build produces.
     Note: There are rpmlint messages (see attachment).
[x]: Sources used to build the package match the upstream source, as provided
     in the spec URL.
[x]: Spec file is legible and written in American English.
[x]: Spec file name must match the spec package %{name}, in the format
     %{name}.spec.
[-]: Package contains systemd file(s) if in need.
[x]: File names are valid UTF-8.
[x]: Useful -debuginfo package or justification otherwise.

===== SHOULD items =====

Generic:
[x]: Reviewer should test that the package builds in mock.
[!]: Buildroot is not present
     Note: Invalid buildroot found:
     %{_tmppath}/%{srcname}-%{version}-%{release}-root-%(%{__id_u} -n)

This is a recommended path for EPEL, so OK.

[x]: Package has no %clean section with rm -rf %{buildroot} (or
     $RPM_BUILD_ROOT)
     Note: %clean present but not required
[x]: If the source package does not include license text(s) as a separate file
     from upstream, the packager SHOULD query upstream to include it.
[x]: Dist tag is present.
[x]: No file requires outside of /etc, /bin, /sbin, /usr/bin, /usr/sbin.
[x]: Final provides and requires are sane (rpm -q --provides and rpm -q
     --requires).
[x]: Package functions as described.
[x]: Latest version is packaged.
[x]: Package does not include license text files separate from upstream.
[x]: Patches link to upstream bugs/comments/lists or are otherwise justified.
[x]: The placement of pkgconfig(.pc) files are correct.
     Note: python-ufc-2.0.5-0.2.fc17.x86_64.rpm :
     /usr/lib64/pkgconfig/ufc-1.pc
[x]: SourceX tarball generation or download is documented.
[x]: SourceX / PatchY prefixed with %{name}.
     Note: Patch0 (ufc-2.0.5-fix-python-module-install.patch) Patch1
     (ufc-2.0.5-really-fix-python-module-install.patch) Source0
     (ufc-2.0.5.tar.gz) Patch2 (ufc-2.0.5-fix-lib-path.patch)
[x]: SourceX is a working URL.
[x]: Description and summary sections in the package spec file contains
     translations for supported Non-English languages, if available.
[x]: Package should compile and build into binary rpms on all supported
     architectures.
[-]: %check is present and all tests pass.
[x]: Packages should try to preserve timestamps of original installed files.
[x]: Spec use %global instead of %define.

===== EXTRA items =====

Generic:
[x]: Rpmlint is run on all installed packages.
     Note: There are rpmlint messages (see attachment).


Rpmlint
-------
Checking: python-ufc-debuginfo-2.0.5-0.2.fc17.x86_64.rpm
          python-ufc-2.0.5-0.2.fc17.src.rpm
          python-ufc-2.0.5-0.2.fc17.x86_64.rpm
python-ufc-debuginfo.x86_64: E: empty-debuginfo-package
python-ufc.src: W: spelling-error %description -l en_US variational -> variation, variegation, motivational
python-ufc.src:30: W: mixed-use-of-spaces-and-tabs (spaces: line 30, tab: line 6)
python-ufc.x86_64: W: spelling-error %description -l en_US variational -> variation, variegation, motivational
python-ufc.x86_64: W: unstripped-binary-or-object /usr/lib64/python2.7/site-packages/ufc/_ufc.so
python-ufc.x86_64: W: devel-file-in-non-devel-package /usr/lib64/pkgconfig/ufc-1.pc
python-ufc.x86_64: W: devel-file-in-non-devel-package /usr/include/ufc.h
3 packages and 0 specfiles checked; 1 errors, 6 warnings.




Rpmlint (installed packages)
----------------------------
# rpmlint python-ufc-debuginfo python-ufc
python-ufc-debuginfo.x86_64: E: empty-debuginfo-package
python-ufc.x86_64: W: spelling-error %description -l en_US variational -> variation, variegation, motivational
python-ufc.x86_64: W: unstripped-binary-or-object /usr/lib64/python2.7/site-packages/ufc/_ufc.so
python-ufc.x86_64: W: devel-file-in-non-devel-package /usr/lib64/pkgconfig/ufc-1.pc
python-ufc.x86_64: W: devel-file-in-non-devel-package /usr/include/ufc.h
2 packages and 0 specfiles checked; 1 errors, 4 warnings.
# echo 'rpmlint-done:'



Requires
--------
python-ufc-debuginfo-2.0.5-0.2.fc17.x86_64.rpm (rpmlib, GLIBC filtered):


python-ufc-2.0.5-0.2.fc17.x86_64.rpm (rpmlib, GLIBC filtered):

    /usr/bin/pkg-config
    python(abi) = 2.7
    swig



Provides
--------
python-ufc-debuginfo-2.0.5-0.2.fc17.x86_64.rpm:

    python-ufc-debuginfo = 2.0.5-0.2.fc17
    python-ufc-debuginfo(x86-64) = 2.0.5-0.2.fc17

python-ufc-2.0.5-0.2.fc17.x86_64.rpm:

    pkgconfig(ufc-1) = 2.0.5
    python-ufc = 2.0.5-0.2.fc17
    python-ufc(x86-64) = 2.0.5-0.2.fc17



Unversioned so-files
--------------------
python-ufc-2.0.5-0.2.fc17.x86_64.rpm: /usr/lib64/python2.7/site-packages/ufc/_ufc.so

MD5-sum check
-------------
https://launchpad.net/ufc/2.0.x/2.0.5/+download/ufc-2.0.5.tar.gz :
  CHECKSUM(SHA256) this package     : 989a8ed018c2682d47262f0f3a5dc970e27b6b6d47d03d5b986d0ff2b3ee5b2a
  CHECKSUM(SHA256) upstream package : 989a8ed018c2682d47262f0f3a5dc970e27b6b6d47d03d5b986d0ff2b3ee5b2a


Python:
[!]: Package contains BR: python2-devel or python3-devel

This is easy to fix you can fix this when importing, also according to the comment on the license the remark regarding the documentation has been fixed.

So with the above issues fixed I _approve_ this package. You can fix these when importing.
Comment 5 Jonathan Underwood 2013-01-23 13:41:00 EST
Thanks Jose. I'm in the process of updating the package to build on rawhide (basically getting BuildRequires right for the new texlive packages) and including the fixes you point to and then will submit a branch request. Much appreciated.
Comment 6 Jonathan Underwood 2013-01-24 09:23:29 EST
Spec URL: http://jgu.fedorapeople.org/python-ufc.spec
SRPM URL: http://jgu.fedorapeople.org/python-ufc-2.0.5-0.3.fc19.src.rpm

%changelog
* Thu Jan 24 2013 Jonathan G. Underwood <jonathan.underwood@gmail.com> - 2.0.5-0.3
- Fix texlive BuildRequires for Fedora >= 18
- Add needed BuildRequires for ghostscript (a2ps)
- Fix BuildRequires for python2-devel

* Mon Oct  1 2012 José Matos <jamatos@fedoraproject.org> - 2.0.5-0.2
- Fix conditionals for Fedora
- Fix path for pkgconfig file
Comment 7 Jonathan Underwood 2013-01-24 09:26:12 EST
New Package SCM Request
=======================
Package Name: python-ufc
Short Description: A unified framework for finite element assembly
Owners: jgu
Branches: f18 el6
InitialCC:
Comment 8 Gwyn Ciesla 2013-01-24 09:28:32 EST
Git done (by process-git-requests).

Note You need to log in before you can comment on or make changes to this bug.